import Jed from 'jed'
import getLocaleData from './getLocaleData'

let i18n

/**
 *
 */
export function gettext(message) {
  return i18n.gettext(message)
}

/**
 *
 */
export function ngettext(msg1, msg2, n) {
  return i18n.ngettext(msg1, msg2, n)
}

/**
 *
 */
export async function initTranslate() {
  const {fallbacks, native, preferences} = await getLocaleData()
  const {languages, locales} = preferences

  for (let i = 0; i < locales.length; i++) {
    const locale = locales[i]

    try {
      return await setupLocale(locale)
    } catch (e) {
      console.log(`missed '${locale}'`)
    }
  }

  for (let i = 0; i < languages.length; i++) {
    const language = language[i]

    if (!fallbacks.hasOwnProperty(language)) {
      continue;
    }
    const locale = fallbacks[language]

    try {
      return await setupLocale(locale)
    } catch (e) {
      console.log(`missed fallback '${locale}'`)
    }
  }

  // At last try the native locale.
  return await setupLocale(native)

  throw 'could not find locale data.'
}


/**
 *
 */
async function setupLocale(locale) {
  const data = await import(`${LOCALES_DIR}${locale}/messages.po`)
  console.log(`found '${locale}'`)
  i18n = new Jed(data)
  return true
}
